﻿//var ROTA_PADRAO = 'http://localhost:49993/' ////DEV
var ROTA_PADRAO = 'http://www.scoutcartola.com.br/' // PROD
//var ROTA_PADRAO = 'http://192.168.0.14:49994/' //DEV

// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('ScoutCartolaApp', ['ionic', 'ScoutCartolaApp.controllers'])


.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.run(function ($rootScope, $ionicLoading, $ionicHistory, $state, $window, $ionicPopup, cacheService, $filter, $interval) {

    var orderBy = $filter('orderBy');

    $rootScope.msgErroPadrao = 'Ops... Desculpe mas não foi possível obter os dados do servidor, verifique sua conexão de dados e tente novamente!';

    $rootScope.times = [{ id: 373, text: 'Atlético-GO', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/Atletico-GO-65.png' },
                    { id: 282, text: 'Atlético-MG', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/2.png' },
                    { id: 293, text: 'Atlético-PR', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/3.png' },
                    { id: 314, text: 'Avaí', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/avai_60x60_.png' },
                    { id: 265, text: 'Bahia', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/bahia_60x60.png' },
                    { id: 263, text: 'Botafogo', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/4.png' },
                    { id: 315, text: 'Chapecoense', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/5.png' },
                    { id: 264, text: 'Corinthians', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/6.png' },
                    { id: 294, text: 'Coritiba', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/7.png' },
                    { id: 283, text: 'Cruzeiro', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/8.png' },
                    { id: 262, text: 'Flamengo', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/10.png' },
                    { id: 266, text: 'Fluminense', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/11.png' },
                    { id: 284, text: 'Grêmio', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/12.png' },
                    { id: 275, text: 'Palmeiras', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/14.png' },
                    { id: 303, text: 'Ponte Preta', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/15.png' },
                    { id: 277, text: 'Santos', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/17.png' },
                    { id: 276, text: 'São Paulo', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/18.png' },
                    { id: 292, text: 'Sport', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/19.png' },
                    { id: 267, text: 'Vasco', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/Vasco-65.png' },
                    { id: 287, text: 'Vitória', checked: false, urlEscudo: 'http://scoutcartola.com.br/Content/images/times/20.png' }];

    $rootScope.exibindoLoading = false;

    $rootScope.timeout = 40000; // timeout padrao

    $rootScope.tokenSessaoValidado = true;
    
    $rootScope.EscalacaoModel = {
        logado: false,
        jogadores: 0,
        escalado: false,
        token: '',
        patrimonio: 100,
        patrimonioRestante: 100,
        formacao: 1,
        mercadoAberto: false,        
        escalacao: [{ indice: 0, jogador: null, nomePosicao: 'goleiro' },
            { indice: 1, jogador: null, nomePosicao: 'lateral' },
            { indice: 2, jogador: null, nomePosicao: 'lateral' },
            { indice: 3, jogador: null, nomePosicao: 'zagueiro' },
            { indice: 4, jogador: null, nomePosicao: 'zagueiro' },
            { indice: 5, jogador: null, nomePosicao: 'meia' },
            { indice: 6, jogador: null, nomePosicao: 'meia' },
            { indice: 7, jogador: null, nomePosicao: 'meia' },
            { indice: 8, jogador: null, nomePosicao: 'meia' },
            { indice: 9, jogador: null, nomePosicao: 'atacante' },
            { indice: 10, jogador: null, nomePosicao: 'atacante' },
            { indice: 11, jogador: null, nomePosicao: 'técnico' }]
    };

    $rootScope.UsuarioModel = {
        time: '',
        cartoleiro: '',
        brasao: ''
    };

    /*
    $rootScope.Formacoes = [{ id: 1, nome: '4-4-2', posicoes: [ 1, 2, 2, 4, 2, 1 ] },
                            { id: 2, nome: '4-3-3', posicoes: [ 1, 2, 2, 3, 3, 1 ] },
                            { id: 3, nome: '3-4-3', posicoes: [ 1, 0, 3, 4, 3, 1 ] },
                            { id: 4, nome: '4-5-1', posicoes: [ 1, 2, 2, 5, 1, 1 ] } ];*/

    $rootScope.Formacoes = [
                            { id: 1, nome: '3-4-3', posicoes: [1, 0, 3, 4, 3, 1] },
                            { id: 2, nome: '3-5-2', posicoes: [1, 0, 3, 5, 2, 1] },
                            { id: 3, nome: '4-3-3', posicoes: [1, 2, 2, 3, 3, 1] },
                            { id: 4, nome: '4-4-2', posicoes: [1, 2, 2, 4, 2, 1] },
                            { id: 5, nome: '4-5-1', posicoes: [1, 2, 2, 5, 1, 1] },
                            { id: 6, nome: '5-3-2', posicoes: [1, 2, 3, 3, 2, 1] },
                            { id: 7, nome: '5-4-1', posicoes: [1, 2, 3, 4, 1, 1] }
                           ];


    $rootScope.Posicoes =  [{ id: 1, nomePlural: 'goleiro(s)', nome: 'goleiro', abr: 'GOL' },
                            { id: 2, nomePlural: 'lateral(is)', nome: 'lateral', abr: 'LAT' },
                            { id: 3, nomePlural: 'zagueiro(s)', nome: 'zagueiro', abr: 'ZAG' },
                            { id: 4, nomePlural: 'meia(s)', nome: 'meia', abr: 'MEI' },
                            { id: 5, nomePlural: 'atacante(s)', nome: 'atacante', abr: 'ATA' },
                            { id: 6, nomePlural: 'técnico(s)', nome: 'técnico', abr: 'TEC' }];

    $rootScope.customAlert = function (msg, titulo) {
        if (titulo == null || titulo == undefined)
            titulo = 'Scout';
        $ionicPopup.alert({
            title: titulo,
            template: msg,
            buttons: [{ text: 'OK' }]
        });
    };

    $rootScope.LoginEfetuadoNoCartola = function (token, redirect) {
        $rootScope.EscalacaoModel.logado = true;
        $rootScope.EscalacaoModel.token = token;
        
        $window.localStorage['access_token'] = $rootScope.EscalacaoModel.token;
                
        var url = $rootScope.ObterRotaPadrao('API/ServicesCartola/ObterDadosTimePrivado?versaoBase=' + cacheService.getVersaoBancoLocal());
        $rootScope.WebApiAutenticado(url,
            function (data) {                
                var resCache = cacheService.tratarConsultaJogadoresEscalacaoComCache(data);

                $rootScope.UsuarioModel = {
                    time: data.nome,
                    cartoleiro: data.cartoleiro,
                    brasao: data.brasao
                };

                $window.localStorage['user_model'] = JSON.stringify($rootScope.UsuarioModel);

                // limpar escalação
                $rootScope.EscalacaoModel.escalacao = [ { indice: 0, jogador: null, nomePosicao: 'goleiro' },
                                                        { indice: 1, jogador: null, nomePosicao: 'lateral' },
                                                        { indice: 2, jogador: null, nomePosicao: 'lateral' },
                                                        { indice: 3, jogador: null, nomePosicao: 'zagueiro' },
                                                        { indice: 4, jogador: null, nomePosicao: 'zagueiro' },
                                                        { indice: 5, jogador: null, nomePosicao: 'meia' },
                                                        { indice: 6, jogador: null, nomePosicao: 'meia' },
                                                        { indice: 7, jogador: null, nomePosicao: 'meia' },
                                                        { indice: 8, jogador: null, nomePosicao: 'meia' },
                                                        { indice: 9, jogador: null, nomePosicao: 'atacante' },
                                                        { indice: 10, jogador: null, nomePosicao: 'atacante' },
                                                        { indice: 11, jogador: null, nomePosicao: 'técnico' }];

                $rootScope.EscalacaoModel.jogadores = data.ITs.length;
                $rootScope.EscalacaoModel.escalado = data.ITs.length == 12;
                $rootScope.EscalacaoModel.patrimonio = data.patrimonio;
                $rootScope.EscalacaoModel.formacao = data.esquema;
                $rootScope.EscalacaoModel.mercadoAberto = data.mercadoAberto;
                
                resCache.data = orderBy(resCache.data, 'posicaoId', false);

                var soma = 0;

                if (data.ITs.length > 0) {
                    $rootScope.TrocarFormacao($rootScope.EscalacaoModel.formacao);
                    for (var i = 0; i < $rootScope.EscalacaoModel.escalacao.length; i++)  
                    {                        
                        $rootScope.EscalacaoModel.escalacao[i].jogador = resCache.data[i];
                        soma += $rootScope.EscalacaoModel.escalacao[i].jogador.valor;
                    }                        
                }                

                $rootScope.EscalacaoModel.patrimonioRestante = data.patrimonio - soma;

                if (redirect)
                {
                    $rootScope.customAlert("Login efetuado com sucesso, agora você já pode usar as funções de escalação!");
                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $state.go('app.home');
                }
            });
    };

    $rootScope.EscalarJogador = function (indice, jogador) {        
        if (jogador.valor > $rootScope.EscalacaoModel.patrimonioRestante)
        {
            $rootScope.customAlert("Você não possui patrimônio para comprar esse jogador!");
            return { sucesso: false, continuarEscalando: false };
        }
        
        var contPos = 0;
        for (var i = 0; i < $rootScope.EscalacaoModel.escalacao.length; i++) {
            if ($rootScope.EscalacaoModel.escalacao[i].jogador != null && $rootScope.EscalacaoModel.escalacao[i].jogador.posicaoId == jogador.posicaoId) {
                contPos++;
            }        
        }

        var formacao = null;
        for (var i = 0; i < $rootScope.Formacoes.length; i++)
            if ($rootScope.Formacoes[i].id == $rootScope.EscalacaoModel.formacao)
                formacao = $rootScope.Formacoes[i];        

        if (formacao.posicoes[jogador.posicaoId-1] == 0) {
            $rootScope.customAlert("Essa formação não permite jogadores dessa posição!");
            return { sucesso: false, continuarEscalando: false };
        }

        if (contPos == formacao.posicoes[jogador.posicaoId-1]) {
            $rootScope.customAlert("Você já possui o máximo de jogadores permitidos dessa posição!");
            return { sucesso: false, continuarEscalando: false };
        }

        if (indice == -1) {
            var cont = 0;
            for (var ind = 0; ind < jogador.posicaoId - 1; ind++)
                cont += formacao.posicoes[ind];
            
            for (var ind = cont; ind < cont + formacao.posicoes[jogador.posicaoId - 1]; ind++)
                if ($rootScope.EscalacaoModel.escalacao[ind].jogador == null) {
                    indice = ind;
                    break;
                }
        }

        $rootScope.EscalacaoModel.patrimonioRestante -= jogador.valor;
        $rootScope.EscalacaoModel.escalacao[indice].jogador = jogador;        
        $rootScope.EscalacaoModel.jogadores++;

        if ($rootScope.EscalacaoModel.jogadores == 12) {
            $ionicPopup.confirm({
                title: 'Time pronto',
                template: 'Seu time já está pronto! Deseja escalar?'
            }).then(function (res) {
                if (res)
                    $rootScope.SalvarTime();
            });
        }

        if (contPos + 1 == formacao.posicoes[jogador.posicaoId-1]) {            
            return { sucesso: true, continuarEscalando: false };
        }

        return { sucesso: true, continuarEscalando: true };
    };

    $rootScope.VenderJogador = function (jogador) {
        $rootScope.EscalacaoModel.escalado = false;

        var indice = -1;
        for (var i = 0; i < $rootScope.EscalacaoModel.escalacao.length; i++)
            if ($rootScope.EscalacaoModel.escalacao[i].jogador != null && $rootScope.EscalacaoModel.escalacao[i].jogador.id == jogador.id) {
                indice = i;
                break;
            }

        if (indice == -1)
        {
            customAlert('Esse jogador não está no seu time');
            return false;
        }

        $rootScope.EscalacaoModel.patrimonioRestante += jogador.valor;
        $rootScope.EscalacaoModel.jogadores--;
        $rootScope.EscalacaoModel.escalacao[indice].jogador = null;

        return true;
    };

    $rootScope.ObterPosicaoPorIndice = function (indice) {
        var formacao = null;
        for (var i = 0; i < $rootScope.Formacoes.length; i++)
            if ($rootScope.Formacoes[i].id == $rootScope.EscalacaoModel.formacao)
                formacao = $rootScope.Formacoes[i];
                
        var cont = 0;
        
        for (var ind = 0; ind < formacao.posicoes.length; ind++) {        
            if (indice >= cont && indice < cont + formacao.posicoes[ind]) {                
                return $rootScope.Posicoes[ind];
            }

            cont += formacao.posicoes[ind];            
        }               

        return $rootScope.Posicoes[ind];
    };

    $rootScope.ExecutarVenderTodos = function () {        
        for (var i = 0; i < $rootScope.EscalacaoModel.escalacao.length; i++)            
            $rootScope.EscalacaoModel.escalacao[i].jogador = null;                            

        $rootScope.EscalacaoModel.patrimonioRestante = $rootScope.EscalacaoModel.patrimonio;
        $rootScope.EscalacaoModel.jogadores = 0;
    };

    $rootScope.VenderTodos = function (showMessage)
    {
        $ionicPopup.confirm({
            title: 'Vender Todos',
            template: 'Deseja vender todos?'
        }).then(function (res) {
            if (res)
                $rootScope.ExecutarVenderTodos();
        });
    }

    $rootScope.SalvarTime = function () {
        var atletas = { ITs: [], esquema: $rootScope.EscalacaoModel.formacao };
        for (var i = 0; i < $rootScope.EscalacaoModel.escalacao.length; i++)
            atletas.ITs.push({ P: $rootScope.EscalacaoModel.escalacao[i].jogador.id });            

        var url = $rootScope.ObterRotaPadrao('API/ServicesCartola/SalvarDadosTime');
        $rootScope.WebApiPostAutenticado(url,
            atletas,
            function (data) {
                $rootScope.EscalacaoModel.escalado = true;
                $rootScope.customAlert('Time escalado com sucesso!');
            });        
    };

    $rootScope.TrocarFormacao = function (formacaoDestinoId) {
        var formacaoDestino = null;
        for (var i = 0; i < $rootScope.Formacoes.length; i++)
            if ($rootScope.Formacoes[i].id == formacaoDestinoId)
                formacaoDestino = $rootScope.Formacoes[i];

        if (formacaoDestino != null) {
            var mensagem = '';
            var problema = false;
            for (var i = 0; i < formacaoDestino.posicoes.length; i++) { // percorrer a lista de posições               
                var cont = 0;
                for (var x = 0; x < $rootScope.EscalacaoModel.escalacao.length; x++) // percorrer a escalação, contando os jogadores por posição
                {
                    if ($rootScope.EscalacaoModel.escalacao[x].jogador != null
                        && $rootScope.EscalacaoModel.escalacao[x].jogador.posicaoId == $rootScope.Posicoes[i].id) 
                        cont++;
                }

                if (cont > formacaoDestino.posicoes[i])
                {
                    var dif = (cont - formacaoDestino.posicoes[i]);
                    problema = true;
                    mensagem = mensagem + '- vender ' + dif + ' ' + $rootScope.Posicoes[i].nomePlural + ';</br>';
                }
            }

            if (problema)
            {                
                $rootScope.customAlert('Antes de trocar pra essa formação, você precisa: <br/>' + mensagem);
                return false;
            }            

            $rootScope.EscalacaoModel.formacao = formacaoDestinoId;
            for (var x = 0; x < $rootScope.EscalacaoModel.escalacao.length; x++) {
                $rootScope.EscalacaoModel.escalacao[x].nomePosicao = $rootScope.ObterPosicaoPorIndice(x).nome;
            }

            return true;
        }
        else
            customAlert('Formação de destino não encontrada');

        return false;
    };

    $rootScope.ChecarSeUsuarioLogado = function () {       
        if ($rootScope.EscalacaoModel.logado == false) {
            var token = $window.localStorage['access_token'];
            if (token != null && token != '') {
                var user = $window.localStorage['user_model'];
                if (user != null)
                    $rootScope.UserModel = JSON.parse(user);
                $rootScope.LoginEfetuadoNoCartola(token, false);
            }            
        }                    
    }

    $rootScope.TokenValidadoComSucesso = function () {
        if ($rootScope.tokenSessaoValidado)
            return;

        $rootScope.tokenSessaoValidado = true;
    };

    $rootScope.IniciarLoginNoCartola = function () {

       // $rootScope.LoginEfetuadoNoCartola('1a8d793c599ddd639136c83ed7a78f8e1373258725670454e5f3138635f513673526333695a735167344d776b5049647678317056794d48774d424f5458345038624d694745517532756946483965446e5764464a5248477264366f6c6e327167317a663834773d3d3a303a7262656e65646963746f2e32303136', true);
       //return;

        try
        {
            // a solução pro logoff completo seria chamar essa URL via window.open https://cartolafc.globo.com/#/logout
            var inAppBrowserRef = window.open('https://login.globo.com/login/438?url=https://cartolafc.globo.com', '_blank', 'location=yes;');

            inAppBrowserRef.addEventListener('loadstart', function () {
                $rootScope.ExibirLoading();
                inAppBrowserRef.hide();
            });

            inAppBrowserRef.addEventListener('loadstop', function () {
                $rootScope.EsconderLoading();
                inAppBrowserRef.show();
            });

            inAppBrowserRef.addEventListener('loaderror', function () {
                $rootScope.EsconderLoading();
                inAppBrowserRef.show();
            });
                        
            timer = setInterval(function () {
                inAppBrowserRef.executeScript({ code: "document.cookie" },
                    function (values) {
                        var data = values[0];
                        var name = "GLBID=";
                        var ca = data.split(';');
                        for(var i = 0; i <ca.length; i++) {
                            var c = ca[i];
                            while (c.charAt(0)==' ') {
                                c = c.substring(1);
                            }
                            if (c.indexOf(name) == 0) {
                                var token = c.substring(name.length,c.length);
                                clearInterval(timer);
                                inAppBrowserRef.close();
                                $rootScope.LoginEfetuadoNoCartola(token, true);
                            }
                        }
                    });
            }, 1000);
        }
        catch (ex) {
            alert("Não foi possível efetuar o login no Cartola");
        }        
    };

    $rootScope.Logoff = function (redirect) {
        $ionicPopup.confirm({
            title: 'Fazer Loggoff',
            template: 'Já vai mesmo parça?'
        }).then(function (res) {
            if (res)
                $rootScope.ExecutarLogoff(redirect);
        });
    }

    $rootScope.ExecutarLogoff = function (redirect) {
        $rootScope.tokenSessaoValidado = false;
        $rootScope.EscalacaoModel.logado = false;
        $rootScope.EscalacaoModel.token = '';
        $window.localStorage['access_token'] = '';

        $rootScope.UsuarioModel = {
            time: '',
            cartoleiro: '',
            brasao: ''
        };

        if (redirect != null && redirect) {
            try {
                var inAppBrowserRefLogoff = window.open('https://cartolafc.globo.com/#/logout', '_blank', 'location=yes;');
                inAppBrowserRefLogoff.hide();

                inAppBrowserRefLogoff.addEventListener('loadstart', function () {
                    $rootScope.ExibirLoading();                    
                });

                inAppBrowserRefLogoff.addEventListener('loadstop', function () {
                    $rootScope.EsconderLoading();
                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $state.go('app.home');
                });

                inAppBrowserRefLogoff.addEventListener('loaderror', function () {
                    $rootScope.EsconderLoading();
                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });

                    $state.go('app.home');
                });
            }
            catch (ex) {
                alert("Não foi possível efetuar o logoff no Cartola");
            }
        }
    };
    
    $rootScope.ExibirLoading = function () {
        $rootScope.exibindoLoading = true;
        $ionicLoading.show({
            content: 'Carregando',
            animation: 'fade-in',
            showBackdrop: true,
            maxWidth: 200,
            showDelay: 0
        });
    }

    $rootScope.EsconderLoading = function () {
        $rootScope.exibindoLoading = false;
        $ionicLoading.hide();
    }

    $rootScope.ToggleGroup = function (group) {
        if ($rootScope.IsGroupShown(group)) {
            $rootScope.shownGroup = null;
        } else {
            $rootScope.shownGroup = group;
        }
    };

    $rootScope.IsGroupShown = function (group) {
        return $rootScope.shownGroup === group;
    };

    $rootScope.ObterRotaPadrao = function (rota) {
        return ROTA_PADRAO + rota;
    };

    $rootScope.WebApiAutenticado = function (urlGet, fnSucess, showLoading) {

        var method = 'GET',
            url = urlGet,
            async = true;

        if (showLoading == null)
            showLoading = true;

        if (showLoading)
            $rootScope.ExibirLoading();

        $.ajax({
            type: method,
            url: url,
            dataType: 'json',
            crossDomain: true,
            cache: true,
            async: async,
            beforeSend: function (xhr) { xhr.setRequestHeader('Token', $rootScope.EscalacaoModel.token); },
            timeout: $rootScope.timeout,            
            success: function (data) {

                $rootScope.trySetTimeoutAjax(data);
                if (showLoading)
                    $rootScope.EsconderLoading();

                if (!data.sucesso) {
                    if (data.error == "access_denied") {
                        $rootScope.ExecutarLogoff();
                        $rootScope.customAlert('Sua sessão expirou, você precisará logar novamente.');
                        return;
                    }

                    // caso uma chamada foi feita com sucesso, significa que o token é valido e que podemos tentar carregar os convites
                    $rootScope.TokenValidadoComSucesso();
                    $rootScope.customAlert(data.message);                                            
                }
                else {
                    // caso uma chamada foi feita com sucesso, significa que o token é valido e que podemos tentar carregar os convites
                    $rootScope.TokenValidadoComSucesso();                    
                    fnSucess(data.data);
                }
            },
            error: function (error) {                
                $rootScope.customAlert($rootScope.msgErroPadrao);

                if (showLoading)
                    $rootScope.EsconderLoading();
            }
        });
    }

    $rootScope.WebApiPostAutenticado = function (urlGet, dataPost, fnSucess, showLoading) {
        var method = 'POST',
            url = urlGet,
            async = true;

        if (showLoading == null)
            showLoading = true;

        if (showLoading)
            $rootScope.ExibirLoading();

        $.ajax({
            type: method,
            url: url,
            dataType: 'json',
            contentType: 'application/json',
            crossDomain: true,
            async: async,
            data: JSON.stringify(dataPost),
            beforeSend: function (xhr) { xhr.setRequestHeader('Token', $rootScope.EscalacaoModel.token); },
            timeout: $rootScope.timeout,            
            success: function (data) {
                $rootScope.trySetTimeoutAjax(data);

                if (showLoading)
                    $rootScope.EsconderLoading();

                if (!data.sucesso) {
                    if (data.error == "access_denied") {
                        $rootScope.ExecutarLogoff();                      
                        $rootScope.customAlert('Sua sessão expirou, você precisará logar novamente.');
                        return;
                    }

                    // caso uma chamada foi feita com sucesso, significa que o token é valido e que podemos tentar carregar os convites
                    $rootScope.TokenValidadoComSucesso();

                    $rootScope.customAlert(data.message);
                }
                else {
                    // caso uma chamada foi feita com sucesso, significa que o token é valido e que podemos tentar carregar os convites
                    $rootScope.TokenValidadoComSucesso();
                    fnSucess(data.data);
                }
            },
            error: function (error) {
                if (showLoading)
                    $rootScope.EsconderLoading();
                $rootScope.customAlert($rootScope.msgErroPadrao);
            }
        });
    };

    $rootScope.WebApiPostAnonimo = function (urlGet, dataPost, fnSucess, showLoading) {
        var method = 'POST',
            url = urlGet,
            async = true;

        if (showLoading == null)
            showLoading = true;

        if (showLoading)
            $rootScope.ExibirLoading();

        $.ajax({
            type: method,
            url: url,
            dataType: 'json',
            contentType: 'application/json',
            crossDomain: true,
            async: async,
            data: JSON.stringify(dataPost),            
            timeout: $rootScope.timeout,
            success: function (data) {
                $rootScope.trySetTimeoutAjax(data);

                if (showLoading)
                    $rootScope.EsconderLoading();

                if (!data.sucesso) {                    
                    $rootScope.customAlert(data.message);
                }
                else {
                    fnSucess(data.data);
                }
            },
            error: function (error) {
                if (showLoading)
                    $rootScope.EsconderLoading();
                $rootScope.customAlert($rootScope.msgErroPadrao);
            }
        });
    };

    $rootScope.AbrirPagina = function (pagina, iniciarNovaNavegacao) {
        if (iniciarNovaNavegacao == null)
            iniciarNovaNavegacao = false;

        exibirIntersistial(function () {
            if (iniciarNovaNavegacao) {
                $ionicHistory.nextViewOptions({
                    disableBack: true
                });
            }
            $state.go('app.' + pagina);
        });
    };


    $rootScope.WebApi = function (urlGet, fnSucess) {
        var method = 'GET',
            url = urlGet,
            async = true;
        $.ajax({
            type: method,
            url: url,
            dataType: 'json',
            crossDomain: true,
            async: async,
            success: function (data) {
                $rootScope.trySetTimeoutAjax(data);
                fnSucess(data);
            },
            error: function (error) {
                alert('Ops... Desculpe mas não foi possível obter os dados do servidor, verifique sua conexão de dados e tente novamente!');
                $rootScope.EsconderLoading();
            }
        });
    };

    $rootScope.ToQueryString = function(obj) {
        if (obj == null)
            return {};
        else
            return obj.join().replace(/:/g, '=').replace(/,/g, '&');
    }

    $rootScope.trySetTimeoutAjax = function (obj) {
        try {
            if (typeof obj.timeout != undefined) {
                $rootScope.timeout = obj.timeout;
            }
        }
        catch (error) {
            $rootScope.timeout = 40000; // padrão
        }
    }

    $rootScope.buyAddfree = function () {
        if (addFree) {
            $rootScope.customAlert("Você já removeu os anúncios, valeu!");
            return;
        }

        $ionicLoading.show();

        var ids = [];
        ids.push(getProductAdfreeName());

        if (/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
            inAppPurchase
                .getProducts(ids)
                .then(function (data) {
                    inAppPurchase
                        .buy(getProductAdfreeName())
                        .then(function (data) {
                            $rootScope.customAlert("Compra finalizada com sucesso, reinicie o App para finalizar o processo!");
                            $ionicLoading.hide();
                            AdMob.hideBanner();
                            intersistialExibido = true;
                        })
                        .catch(function (err) {
                            $ionicLoading.hide();
                        });
                })
                .catch(function (err) {
                    $rootScope.customAlert("Um erro ocorreu ao acessar a loja!");
                    $ionicLoading.hide();
                });
        }
        else {
            inAppPurchase
                .buy(getProductAdfreeName())
                .then(function (data) {
                    $rootScope.customAlert("Compra finalizada com sucesso, reinicie o App para finalizar o processo!");
                    $ionicLoading.hide();
                    AdMob.hideBanner();
                    intersistialExibido = true;
                })
                .catch(function (err) {
                    $ionicLoading.hide();
                });
        }
    };
    
    $rootScope.AutenticarToken = function() {        
        // O objetivo desse método é registrar o token para o push
        if (tokenPush != '' && tokenPush != null) {

            //buscar o token velho
            tokenPushVelho = window.localStorage.getItem('tokenPushVelho');
            idToken = window.localStorage.getItem('idToken');
            
            console.log('velho: ' + tokenPushVelho);
            console.log('novo: ' + tokenPush);
            
            var url = $rootScope.ObterRotaPadrao('API/ScoutToken/SalvarTokenScout');

            //pegar da memoria do cel o token antigo, caso tenha.
            if ((tokenPushVelho == ''
                || tokenPushVelho == null
                || tokenPushVelho != tokenPush)) { //se token velho 
                
                  //Salvar novo push na base e no cache  + notificações 
                  var tokenComPlataforma = tokenPush;

                  if (/(android)/i.test(navigator.userAgent)) {
                      tokenComPlataforma = tokenComPlataforma + '|A';
                  } else if (/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
                      tokenComPlataforma = tokenComPlataforma + '|I';
                  } else {
                      return;
                  }
            
                  $rootScope.WebApiPostAnonimo(url,
                      {
                          IdToken: idToken,
                          TokenAtual: tokenComPlataforma
                      },
                      function(data) {                            
                          // Salvar o token atualizado
                          window.localStorage.setItem('tokenPushVelho', tokenPush);
                          tokenPushVelho = tokenPush;
                          tokenPushRegistrado = true;
                            
                          $interval.cancel($rootScope.TokenInterval); // Evitar novas chamadas

                          if (idToken != data) { // se o id mudou atualizar
                              idToken = data;
                              window.localStorage.setItem('idToken', idToken);
                          }                            
                      },
                      false);                                    

            }
            else // se o token não mudou, não fazer nada                
                $interval.cancel($rootScope.TokenInterval);            
        }        
    };

    $rootScope.PushRecebido = function (data) {
        if (data.additionalData.coldstart) {            
            $state.go('app.home');            
        }
        else {            
            $ionicPopup.alert({
                title: data.title,
                template: data.message
            });            
        }
    };

    
    $rootScope.TokenInterval = $interval(function () { // tentar recarregar a cada segundo 
        $rootScope.AutenticarToken();
    }, 1000 * 60, 60);
})

.service('cacheService', function () {
    var clubes = [];    
    var atletas = [];
    var versaoBancoLocal = '';
    var versaoBancoCarregada = false;
    
    var tratarConsultaPartidasComCache = function (data) {

        tratarBases(data);

        var partidas = [];

        for (var i = 0; i < data.ITs.length; i++) {
            console.log(data.ITs[i].TA);
            var clubeA = {};
            for (k = 0; k < clubes.length; k++)
                if (clubes[k].TeamId == data.ITs[i].TA)
                    clubeA = clubes[k];

            var clubeB = {};
            for (k = 0; k < clubes.length; k++)
                if (clubes[k].TeamId == data.ITs[i].TB)
                    clubeB = clubes[k];            

            var clubeAResult = { "ID": clubeA.ID, "Nome": clubeA.N, "Escudo": clubeA.ES, "Detalhe": {} };
            var clubeBResult = { "ID": clubeB.ID, "Nome": clubeB.N, "Escudo": clubeB.ES, "Detalhe": {} };

            console.log(clubeAResult);
            console.log(clubeBResult);

            clubeAResult.Detalhe = {
                "DerrotaA": data.ITs[i].DA,
                "EmpateA": data.ITs[i].EA,
                "VitoriaA": data.ITs[i].VA,
                "GolsMarcadosA": data.ITs[i].GMA,
                "GolsSofridosA": data.ITs[i].GSA,
                "PartidasComGolSofridoA": data.ITs[i].PGSA,
                "PartidasComGolA": data.ITs[i].PGA,
                "QuantidadePartidasA": data.ITs[i].QPA,
                "Top5A": data.ITs[i].T5A,
            };

            clubeBResult.Detalhe = {
                "DerrotaB": data.ITs[i].DB,
                "EmpateB": data.ITs[i].EB,
                "VitoriaB": data.ITs[i].VB,
                "GolsMarcadosB": data.ITs[i].GMB,
                "GolsSofridosB": data.ITs[i].GSB,
                "PartidasComGolSofridoB": data.ITs[i].PGSB,
                "PartidasComGolB": data.ITs[i].PGB,
                "QuantidadePartidasB": data.ITs[i].QPB,
                "Top5B": data.ITs[i].T5B,
            };

            partidas.push({
                "clubeA": clubeAResult,
                "clubeB": clubeBResult,                
                "Local": data.ITs[i].L,
                "DataHora": data.ITs[i].D
            });
        }

        if (data.Cache.Versao != '') // não for nova versão
        {
            versaoBancoLocal = data.Cache.Versao;
            salvarVersaoBancoLocal(versaoBancoLocal);
        }

        return { "sucesso": true, "data": partidas };
    };

    var tratarConsultaJogadoresComCache = function (data) {
        
        tratarBases(data);

        var res = [];

        for (var i = 0; i < data.ITs.length; i++) {

            var atleta = {};
            for (k = 0; k < atletas.length; k++)                
                if (atletas[k].PlayerId == data.ITs[i].P)                     
                    atleta = atletas[k];
            
            var clube = {};
            for (k = 0; k < clubes.length; k++)
                if (clubes[k].TeamId == atleta.C)
                    clube = clubes[k];

            var clubeCasa = {};
            for (k = 0; k < clubes.length; k++)
                if (clubes[k].TeamId == data.ITs[i].TC)
                    clubeCasa = clubes[k];

            var clubeFora = {};
            for (k = 0; k < clubes.length; k++)
                if (clubes[k].TeamId == data.ITs[i].TF)
                    clubeFora = clubes[k];

            res.push({
                "jogador": atleta.N,
                "id": atleta.PlayerId,
                "equipe": clube.N,
                "urlEscudo": clube.ES,
                "position": atleta.PT,
                "posicaoId": atleta.PT_ID,
                "penalti": atleta.P,
                "falta": atleta.F,
                "escanteio": atleta.E,
                "casa": 0,
                "fora": 0,
                "total": 0,
                "mediaCasa": data.ITs[i].MC,
                "mediaFora": data.ITs[i].MF,
                "mediaTotal": data.ITs[i].MT,
                "totalCasa": data.ITs[i].C,
                "totalFora": data.ITs[i].F,
                "totalTotal": data.ITs[i].T,
                "valor": atleta.PN,
                "jogos": atleta.GN,
                "pontosMedia": atleta.AN,
                "variacao": atleta.VAR,
                "pontosUltima": atleta.ULT,
                "timeCasa": clubeCasa.N,
                "timeFora": clubeFora.N,
                "escudoCasa": clubeCasa.ES,
                "escudoFora": clubeFora.ES,
                "statusName": data.ITs[i].ST,
                "statusId": data.ITs[i].STID,                
                "escalado": false,
            });            
        }

        if (data.Cache.Versao != '') // não for nova versão
        {
            versaoBancoLocal = data.Cache.Versao;
            salvarVersaoBancoLocal(versaoBancoLocal);
        }

        return { "sucesso": true, "data": res, "ordem": data.O };
    };

    var tratarConsultaJogadoresEscalacaoComCache = function (data) {

        tratarBases(data);

        var res = [];

        for (var i = 0; i < data.ITs.length; i++) {

            var atleta = {};
            for (k = 0; k < atletas.length; k++)
                if (atletas[k].PlayerId == data.ITs[i].P)
                    atleta = atletas[k];

            var clube = {};
            for (k = 0; k < clubes.length; k++)
                if (clubes[k].TeamId == atleta.C)
                    clube = clubes[k];

            res.push({
                "id": atleta.PlayerId,
                "jogador": atleta.N,
                "equipe": clube.N,
                "urlEscudo": clube.ES,
                "position": atleta.PT,
                "posicaoId": atleta.PT_ID,
                "valor": atleta.PN,
                "jogos": atletas.GN,
                "mediaPontuacao": atletas.AN,
                "statusId": data.ITs[i].STID,   
                "escalado": true,                
            });           
        }

        if (data.Cache.Versao != '') // não for nova versão
        {
            versaoBancoLocal = data.Cache.Versao;
            salvarVersaoBancoLocal(versaoBancoLocal);
        }

        return { "sucesso": true, "data": res };
    };


    var tratarConsultaTimesComCache = function (data) {

        tratarBases(data);

        var res = [];

        for (var i = 0; i < data.ITs.length; i++) {            

            var clube = {};
            for (k = 0; k < clubes.length; k++) {                
                if (clubes[k].TeamId == data.ITs[i].TI)
                    clube = clubes[k];
            }            

            res.push({                
                "Equipe": clube.N,
                "UrlEscudo": clube.ES,                
                "casa": 0,
                "fora": 0,
                "total": 0,
                "mediaCasa": data.ITs[i].MC,
                "mediaFora": data.ITs[i].MF,
                "mediaTotal": data.ITs[i].MT,
                "totalCasa": data.ITs[i].C,
                "totalFora": data.ITs[i].F,
                "totalTotal": data.ITs[i].T,

            });

        }

        if (data.Cache.Versao != '') // não for nova versão
        {
            versaoBancoLocal = data.Cache.Versao;
            salvarVersaoBancoLocal(versaoBancoLocal);
        }

        return { "sucesso": true, "data": res, "ordem": data.O };
    };

    var tratarBases = function (data) {
        // salvar clubes no banco local
        if (data.Clubes.length > 0) {
            clubes = data.Clubes;
            if (data.Cache.Clubes)
                salvarNoCache('clubes', data.Clubes);
            else
                salvarNoCache('clubes', []);
        }

        // salvar atletas no banco local
        if (data.Atletas.length > 0) {
            atletas = data.Atletas;
            if (data.Cache.Atletas)
                salvarNoCache('atletas', data.Atletas);
            else
                salvarNoCache('atletas', []);
        }
    }

    var getVersaoBancoLocal = function () {

        try {
            if (!versaoBancoCarregada) {
                versaoBancoLocal = window.localStorage.getItem("versaoBanco");

                if (versaoBancoLocal == null || typeof versaoBancoLocal.length == undefined || versaoBancoLocal == '')
                    versaoBancoLocal = '';

                versaoBancoCarregada = true;

                if (versaoBancoLocal != '') {
                    clubes = getCache("clubes");
                    atletas = getCache("atletas");

                    if (clubes == null || clubes == 'null' ||
                        atletas == null || atletas == 'null')
                        versaoBancoLocal = '';
                    else if (typeof clubes.length == undefined || clubes.length == 0
                        || typeof atletas.length == undefined || atletas.length == 0)
                        versaoBancoLocal = '';
                }
            }
        }
        catch (err) { // Fallback em caso de qualquer problema, com essa versão a app vai retornar tudo evitando erros
            versaoBancoLocal = 'ERRO';
        }

        return versaoBancoLocal;
    };

    var salvarNoCache = function (chave, objeto) {
        window.localStorage.setItem("cache" + chave, JSON.stringify(objeto));
    }

    var getCache = function (chave) {
        if (window.localStorage.getItem("cache" + chave) != null) {
            return JSON.parse(window.localStorage.getItem("cache" + chave));
        }
        return [];
    }

    var salvarVersaoBancoLocal = function (chave) {
        window.localStorage.setItem("versaoBanco", chave);
    }

    var limparCache = function () {
        try {
            salvarNoCache('atletas', null);
            salvarNoCache('clubes', null);            
            salvarVersaoBancoLocal(null);
        }
        catch (err) {
        }
    }

    return {
        getVersaoBancoLocal: getVersaoBancoLocal,
        tratarConsultaTimesComCache: tratarConsultaTimesComCache,
        tratarConsultaJogadoresComCache: tratarConsultaJogadoresComCache,
        tratarConsultaPartidasComCache: tratarConsultaPartidasComCache,
        tratarConsultaJogadoresEscalacaoComCache: tratarConsultaJogadoresEscalacaoComCache
    };

})

.service('sessionService', function () {
    var partida = {};
    var partidas = [];
    var obj = {};

    var salvarPartidas = function (newObj) {
        partidas = newObj;
    };

    var getPartidas = function () {
        return partidas;
    };

    var salvarPartida = function (newObj) {
        partida = newObj;
    };

    var getPartida = function () {
        return partida;
    };

    var getStorage = function () {
        return obj;
    };

    return {        
        getPartida: getPartida,
        salvarPartida: salvarPartida,
        getPartidas: getPartidas,
        salvarPartidas: salvarPartidas,
        getStorage: getStorage
    };

})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })

  .state('app.scoutconfronto', {
      url: '/scoutconfronto',
      cache: false,
      views: {
          'menuContent': {
              templateUrl: 'templates/scoutConfronto.html',
              controller: 'ScoutConfrontationCtrl'
          }
      }
  })

.state('app.scoutconfrontosDetalhe', {
    url: '/scoutconfrontosDetalhe',
    cache: false,
    views: {
        'menuContent': {
            templateUrl: 'templates/scoutConfrontoDetalhe.html',
            controller: 'ScoutConfrontationDetalheCtrl'
        }
    }
})

  .state('app.scoutjogador', {
      url: '/scoutjogador',
      cache: false,
    views: {
      'menuContent': {
          templateUrl: 'templates/scoutJogador.html',
          controller: 'ScoutPlayerCtrl'
      }
    }
  })

  .state('app.scouttime', {
      url: '/scouttime',
      cache: false,
      views: {
          'menuContent': {
              templateUrl: 'templates/scoutTime.html',
              controller: 'ScoutTeamCtrl'
          }
      }
  })

  .state('app.escalacao', {
      url: '/escalacao',
      cache: false,
      views: {
          'menuContent': {
              templateUrl: 'templates/escalacao.html',
              controller: 'EscalacaoCtrl'
          }
      }
  })

    .state('app.escalacaosugestao', {
        url: '/escalacaosugestao',
        cache: false,
        views: {
            'menuContent': {
                templateUrl: 'templates/escalacaoSugestao.html',
                controller: 'EscalacaoSugestaoCtrl'
            }
        }
    })

  .state('app.home', {
      url: '/home',
      cache: false,
      views: {
          'menuContent': {
              templateUrl: 'templates/home.html',
              controller: 'HomeCtrl'
          }
      }
  })

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/home');
});
