﻿angular.module('ScoutCartolaApp.controllers').controller('EscalacaoCtrl', function ($scope, $ionicModal, $http, $ionicLoading, $state, sessionService, $filter) {

    var orderBy = $filter('orderBy');

    $scope.items = [];
    $scope.storageLocal = { formacaoSelecionada: 1 };
    $scope.formacoesLocal = [];

    $scope.CarregarTela = function ()
    {        
        $scope.storageLocal.formacaoSelecionada = $scope.EscalacaoModel.formacao;
        $scope.formacoesLocal = $scope.Formacoes;        
        $scope.items = $scope.EscalacaoModel.escalacao;
    };

    $scope.EscalarJogadorPorIndice = function (indice) {
        sessionService.getStorage().posicaoId = $scope.ObterPosicaoPorIndice(indice).id;        
        $state.go('app.scoutjogador');
    };

    $scope.TentarMudarFormacao = function (indice) {
        if (!$scope.TrocarFormacao($scope.storageLocal.formacaoSelecionada)) // senão for possível trocar voltar a combo para a posição antiga
            $scope.storageLocal.formacaoSelecionada = $scope.EscalacaoModel.formacao;
        else
            $scope.items = $scope.EscalacaoModel.escalacao;
    };

    $scope.CarregarTela();
})

