﻿angular.module('ScoutCartolaApp.controllers').controller('HomeCtrl', function ($scope, $ionicModal, $http, $ionicLoading) {
            
    $scope.data = [];
    $scope.isAndroid = ionic.Platform.isAndroid();
    $scope.isWindowsPhone = ionic.Platform.isWindowsPhone();
    $scope.ano = new Date().getFullYear();

    var url = $scope.ObterRotaPadrao('API/ServicesCarregamentoStats/obterUltimoCarregamentoStats');

    $scope.ExibirLoading();

    $scope.WebApi(url,
            function (data) {
                if (typeof (data.sucesso) == 'undefined')
                    alert($scope.msgErroPadrao);

                if (data.sucesso) {
                    $scope.data = data.data;
                }
                else {
                    alert(data.message);
                }
                            
                $scope.EsconderLoading();
        });

    $scope.ChecarSeUsuarioLogado();
});