﻿//======admob code start=============
function getProductAdfreeName() {
    if (/(ipod|iphone|ipad)/i.test(navigator.userAgent)) 
        return 'scout.adfree' + new Date().getFullYear();

    return 'adfree' + new Date().getFullYear();
    //return 'adfree';
}

var admobid = {};
var addFree = false;
var intersistialExibido = false;
var intersistialCarregado = false;
var tokenPush = '';
var tokenPushVelho = '';
var idToken = '';

if (/(android)/i.test(navigator.userAgent)) {
    admobid = { // for Android
        banner: 'ca-app-pub-2010287833645381/8045783353',
        interstitial: 'ca-app-pub-2010287833645381/9522516558'
    };
} else if (/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
    admobid = { // for iOS
        banner: 'ca-app-pub-2010287833645381/7540165754',
        interstitial: 'ca-app-pub-2010287833645381/5562500959'
    };
} else {
    admobid = { // for Windows Phone
        banner: 'ca-app-pub-2010287833645381/4308254952',
        interstitial: 'ca-app-pub-2010287833645381~1354788552'
    };
}

if ((/(ipad|iphone|ipod|android|windows phone)/i.test(navigator.userAgent))) {
    document.addEventListener('deviceready', initApp, false);
} else {
    initApp();
}

function initApp() {
    //Inicialiar o PUSH
    inicializarPush();

    if (ionic.Platform.platform() == 'win64' || ionic.Platform.platform() == 'win32')
        return;

    if (!AdMob) { return; }

    try {
        inAppPurchase
            .restorePurchases()
            .then(function (purchases) {
                if (purchases.length == 0)
                    createBanner();
                else {
                    for (var i = 0; i < purchases.length; i++) {
                        if (purchases[i].productId == getProductAdfreeName())
                            addFree = true;
                    }
                }

                if (!addFree)
                    createBanner();
            })
            .catch(function (err) {
                safeAlert('Ops, ocorreu um erro ao acessar a loja de produtos');
                createBanner();
            });
    }
    catch (ex)
    {
        safeAlert('Ops, ocorreu um erro ao acessar a loja de produtos');
        createBanner();
    }
}

function createBanner() {
    AdMob.createBanner({
        adId: admobid.banner,
        isTesting: false,
        overlap: false,
        offsetTopBar: false,
        position: AdMob.AD_POSITION.BOTTOM_CENTER,
        bgColor: 'black'
    });

    AdMob.prepareInterstitial({
        adId: admobid.interstitial,
        autoShow: false
    });

    document.addEventListener('onAdLoaded', function (data) {
        if (data.adType == 'interstitial') {
            intersistialCarregado = true;
        }
    });
}

function safeAlert(msg) {
    if ((ionic.Platform.isWindowsPhone() || ionic.Platform.platform() == 'win64' || ionic.Platform.platform() == 'win32'))
        var messageDialog = new Windows.UI.Popups.MessageDialog(msg);
    else
        alert(msg);
}

function exibirIntersistial(success) {
    try {
        if (addFree) {
            success();
            return;
        }

        if (ionic.Platform.platform() == 'win64' || ionic.Platform.platform() == 'win32') {
            success();
            return;
        }

        if (!AdMob) {
            success();
            return;
        }

        if (intersistialCarregado && !intersistialExibido) {
            intersistialExibido = true;
            AdMob.showInterstitial();
            success();
        }
        else {
            success();
        }
    }
    catch (err) {
        success();
    }
}

//=======AdMob Code End=======

function inicializarPush() {

    try {
        var push = PushNotification.init({
            android: {
                senderID: "229620198254",
                icon: "icone_notif",
                iconColor: "#ff8319"
            },
            ios: {
                alert: "true",
                badge: "false",
                sound: "true"
            },
            windows: {}
        });

        push.on('registration', function (data) {
            tokenPush = data.registrationId;
        });

        push.on('notification', function (data) {
            angular.element(document.getElementsByTagName('body')[0]).scope().PushRecebido(data);
        });

        push.on('error', function (e) {
            console.log(e.message);
        });
    }
    catch (err) {
        //alert(err);
    }
}
